View Issue Details

IDCategoryLast Update
0008067bugs2020-05-06 00:48
ReporterTremeschinAssigned Topaul 
Reproducibilityalways 
Status newResolutionopen 
PlatformLinuxOSArch LinuxOS Versionrolling
Product Version6.0-pre1 
Fixed in Version 
Summary0008067: MIDI notes not being deselected properly when exiting internal edit mode in regions, causing unwanted resizes but not transposes
DescriptionSometimes my MIDI notes were disappearing suddenly only until I noticed they weren't being deselected properly when editing two midi regions while still in edit mode or changing to grab mode and the selections were still there (explained better on steps to reproduce)

As some notes were still incorrectly selected whenever I resized another region note, all the selected notes were being resized but weirdly not transposed

This is getting somewhat annoying because whenever I want to make a pluck more tight by ever so slightly shortening its chords notes, I sometimes accidentally have some lead or drums MIDI notes still wrongly selected and they get zero-lenght-ed more often than not

It's a bit hard to explain in a narrative so I think it's better to pay attention on the steps to reproduce
Steps To Reproduce1. Create MIDI track
2. Create two distinct regions (A and B)
3. Place a MIDI note on each of the regions A and B
4. Enter internal edit mode
5. Select a MIDI note on region A
6. While still in internal edit mode, select region B MIDI note

[Note: the MIDI note selected from region A should still be selected, here is where the bug begins, it really should be deselected]

7. Now the two midi notes should be "incorrectly" selected / "grouped"

7.x (optional) Enter grab mode and click a blank spot on the editor playlist, the two regions will be deselected but not the notes

8.1. When resizing either notes, both will be resized (wrong behavior)
8.2. When transposing either notes, only the one you clicked will be transposed (right behavior)


To bypass this issue I'm having to either before exiting internal midi note click a blank spot within that MIDI region file to deselect the notes or manually clicking a blank spot with internal edit mode on on all the regions I forgot to do the first thing

The photos I included, their names are corresponding to the step number here, right after that action was done
Additional Information- Ardour6 compiled from master, commit 860b36b (fresh compilation)
- waf configure arguments: "--optimize --cxx11"

Renamed [~/.config/ardour6] to [~/.config/ardour6.bak] for loading a blank configuration (as the problem could be in my config?) however bug still occurred

Tagsediting, Editor, MIDI region, notes, region, resize

Activities

Tremeschin

2020-04-28 19:34

reporter  

3.png (20,361 bytes)
3.png (20,361 bytes)
5.png (20,617 bytes)
5.png (20,617 bytes)
6.png (19,615 bytes)
6.png (19,615 bytes)

Tremeschin

2020-04-28 20:39

reporter   ~0023994

Got blocked from doing "more than 10 actions per 3600 seconds" so here's the remaining images

7-x.png (23,030 bytes)
7-x.png (23,030 bytes)
8-1.png (50,668 bytes)
8-1.png (50,668 bytes)
8-2.png (18,139 bytes)
8-2.png (18,139 bytes)

Xard

2020-05-01 08:59

reporter   ~0024019

Hello,

I ran into this kind of issue as well and I confirm this is happening with ardour-6.0.rc1.95 build: Selected notes from other regions stay selected even if you click empty space which usually should deselect everything but it doesn't deselect notes from another region.

One slightly faster mitigation for this is hitting ESC as seems to always deselect everything without having to switch modes.

Tremeschin

2020-05-01 18:32

reporter   ~0024024

As far as I can tell pressing ESC only deselect the notes if you are still on the edit more or with the regions with issues selected..

I selected some notes from some regions, pressing ESC works, but if after selecting the notes I click a blank space on the playlist for deselecting the MIDI regions , pressing ESC seems not to deselect the MIDI notes

Only if I get back to edit mode and press ESC that'll work as the regions with the incorrectly selected notes get selected and then the notes deselected

Another way is to go into grab mode and select the regions with issues and press ESC, deselecting only the notes from the selected regions

Oh wow that was a lot of "select" and "deselect" words in there lol hopefully it wasn't too confusing

paul

2020-05-01 23:45

administrator   ~0024028

Should be fixed in master now, though I don't have a good track record for testing this sort of thing. Let me know!

Tremeschin

2020-05-02 00:41

reporter   ~0024029

paul, these commits did fixed the original problems (notes not being deselected) but brought some new issues:

First, it's somewhat annoying when my mouse leaves the midi region, the notes I selected visually seem deselected, they're only shown selected when the mouse enters again inside the region while the edit mode is still turned on.

I think keeping them visually and internally selected like the old way fits better (this might be a side effect of the new code as well as the next paragraph?)

Secondly (and weirdly to explain), whenever I make my first selection inside a midi region while I still can shift+click+drag to select more notes I can't click+drag to select a new note group, I have to click a blank spot OUTSIDE the region (probably do some action that unblocks this region? like changing to the grab mode and coming back to the edit mode as that "resets the region" and let me select a new note group).

Tremeschin

2020-05-02 00:47

reporter   ~0024030

(Been into a session less than 5 minutes in and sorry didn't notice at first) about the first issue I talked about, it's half true: the notes seem deselected when the mouse leaves the midi region but when I zoom in / out they are updated and visually shown selected, but still can't make new selections after zooming in / out, I have to "reset" the region by doing some other action outside it or changing modes and going back

paul

2020-05-02 01:08

administrator   ~0024031

will fix those. I understand the problem. when the mouse leaves a MidiRegion while in internal edit mode, we change the display of the region to indicate that it's no longer editable, but that's no longer true.

Tremeschin

2020-05-02 18:36

reporter   ~0024039

Hey, looks like this is 90% fixed (thanks paul !!), just pulled master (currently commit 11ec81f) and MIDI editing is totally usable now but a single caveat (that is not as annoying as the other ones, can live with but better be fixed):

When a MIDI note is selected (single or group) and I and click a empty spot on the playlist while still in edit mode, those notes get internally... locked(?) and deselected(?) but visually they are selected and I can't resize them.

In other words, clicking blank spot on playlist locks the previous selected notes from being resized while still being visually selected, have to deselect all or select them again for resizing individually or by group.

Sorry if I'm being a bit annoying but I guess this helps with the progress and usability of Ardour6 :)

Xard

2020-05-03 08:06

reporter   ~0024043

I'll test this as soon as the official pre release nightly build featuring this is out.

As a side mention one thing which bothers me related to this is that I really can't from the UI if notes are selected or not. I'm not sure if this is a bug or something else yet.

Xard

2020-05-03 08:15

reporter   ~0024044

Confirmed: The note selection not being visible for me was just matter of the selected note border color. Setting it less saturated color between red and white cured that problem.

Xard

2020-05-03 08:19

reporter   ~0024045

Yet adding one more detail to last one (sorry, haven't found edit here) if the note body color is also supposed to change when selected that doesn't happen currently at all.

paul

2020-05-03 13:50

administrator   ~0024049

Selection status is only indicated by the outline at present.

paul

2020-05-05 20:13

administrator   ~0024076

as of 505bd41ad47 i declare this one resolved !

let me know :)

Tremeschin

2020-05-05 21:59

reporter   ~0024077

One single last quirk (I really tryharded to break this):

Selecting some notes from a midi region A and drawing a new note onto another region / drawing a new midi region with draw mode does not visually deselect the old notes and the behavior is well defined if I draw a new note in another region:

1. If I don't exit edit mode only the new drawn notes will be resized even if I click to resize the old ones
2. If i switch to grab mode and come back into edit mode, all notes (old + new) will be resized which goes onto the original problem

This also happens if I do the following: select notes from region A, go onto draw mode and click another region's note, this also keeps both selected as if I had created a new note like the previous steps.

I can virtually have infinite notes selected wrong if I keep drawing new regions / drawing new notes.

All of this doesn't happen if I'm only tinkering with a single midi region, only happens when 2+ regions are involved.

If I'd guess deselecting all notes when entering draw mode (worse) or deselecting all previous notes but the new drawn / clicked note (better) will fix this :)

paul, don't kill me /s

paul

2020-05-06 00:02

administrator   ~0024078

give f546b38f422 a try

Tremeschin

2020-05-06 00:48

reporter   ~0024080

I tried really really really really hard to break this and I could only find one more issue that might be the last one to completely fix this issue (hopefully) LOL, though midi editing was really smooth

(disclaimer, this shouldn't really happen too often on a casual session with midi editing, it's very very specific the actions)

1. Create two midi regions
2. Enter in draw mode, draw each region a note
3. On the region you last drew a note, draw another note
4. Enter edit mode and select the other region note
5. Press Ctrl + Z

Both notes will be selected and yet again only one will be resized correctly if still in edit mode while switching to grab mode and edit mode will make both be resized altogether

In my opinion where this could go wrong is when composing music and moving from midi track to another like editing drums + bass

I can't really guess on what's going on though it looks like the undo function isn't deselecting the last note when another were deleted? There can be other issues on the undo function regarding this as well (?)

I'd consider the original issue fixed, though if this very specific yet another quirk gets a workaround or a fix other stuff can potentially break?? << this is my fear, reporting in yet again

Anyways, feel free to give that edge case a try or closing this issue :) Thanks paul !!

Issue History

Date Modified Username Field Change
2020-04-28 19:34 Tremeschin New Issue
2020-04-28 19:34 Tremeschin Tag Attached: editing
2020-04-28 19:34 Tremeschin Tag Attached: Editor
2020-04-28 19:34 Tremeschin Tag Attached: MIDI region
2020-04-28 19:34 Tremeschin Tag Attached: notes
2020-04-28 19:34 Tremeschin Tag Attached: region
2020-04-28 19:34 Tremeschin Tag Attached: resize
2020-04-28 19:34 Tremeschin File Added: 3.png
2020-04-28 19:34 Tremeschin File Added: 5.png
2020-04-28 19:34 Tremeschin File Added: 6.png
2020-04-28 20:39 Tremeschin File Added: 7-x.png
2020-04-28 20:39 Tremeschin File Added: 8-1.png
2020-04-28 20:39 Tremeschin File Added: 8-2.png
2020-04-28 20:39 Tremeschin Note Added: 0023994
2020-04-29 22:15 paul Assigned To => paul
2020-05-01 08:59 Xard Note Added: 0024019
2020-05-01 18:32 Tremeschin Note Added: 0024024
2020-05-01 23:45 paul Note Added: 0024028
2020-05-02 00:41 Tremeschin Note Added: 0024029
2020-05-02 00:47 Tremeschin Note Added: 0024030
2020-05-02 01:08 paul Note Added: 0024031
2020-05-02 18:36 Tremeschin Note Added: 0024039
2020-05-03 08:06 Xard Note Added: 0024043
2020-05-03 08:15 Xard Note Added: 0024044
2020-05-03 08:19 Xard Note Added: 0024045
2020-05-03 13:50 paul Note Added: 0024049
2020-05-05 20:13 paul Note Added: 0024076
2020-05-05 21:59 Tremeschin Note Added: 0024077
2020-05-06 00:02 paul Note Added: 0024078
2020-05-06 00:48 Tremeschin Note Added: 0024080